#!/usr/bin/env python
#*********************************************************************
# $Id: client-mysql-cipher.py 165 2008-12-22 21:19:08Z timo $
#
# CTF-VIS
# Visualization of Scoreboard and other Stuff for
# Capture the Flag - Games
#
# written by Timo Boettcher
# ctf-vis (near) spida (.) net
#
# (C) 2006 Timo Boettcher
# This is free software. You may redistribute copies of it under the
# terms of the GNU General Public License (Version 2)
# <http://www.gnu.org/licenses/gpl.html>.
# There is NO WARRANTY, to the extent permitted by law.
#
#*********************************************************************

try:
	import sys
	import getopt

	import MySQLdb
	from twisted.internet import reactor
	import time

	from client import *
	#from plugins.PluginDisplayScrollingScore import CtfTeam, ScoreState, NewTimeAnnouncementRequest, NewScoreAnnouncementRequest, Score
	#from plugins.PluginDisplayScore import CtfTeam, ScoreState, NewTimeAnnouncementRequest, NewScoreAnnouncementRequest, Score
	from plugins.PluginDisplayScoreKoth import CtfTeam, ScoreState, NewTimeAnnouncementRequest, NewScoreAnnouncementRequest, Score

	from plugins.PluginDisplayScoreKoth import NewScoreKothAnnouncementRequest
	from plugins.PluginDisplayScoreHistory import NewScoreHistoryAnnouncementRequest
except ImportError, err:
	print "couldn't load module. %s" % (err)
	sys.exit(2)


class MyERROR(Exception):
	def __init__(self, value):
		self.value = value

	def __str__(self):
		return repr(self.value)

class GameDatabaseConnection:
	def __init__(self, evManager, MysqlOptions, GameOptions, Frequency):
		(self.MYSQLHOST,self.MYSQLUSERNAME,self.MYSQLPASSWORD,self.MYSQLDATABASE) = MysqlOptions
		(self.GAMEID,self.KOTHSERVICEID,self.KOTHTEAMID) = GameOptions
		self.Frequency = Frequency

		self.LastPoll = time.time()

		self.TimeStart = 0
		self.TimeEnd = 0
		self.evManager = evManager
		self.evManager.RegisterListener(self)

		self.ScoreState = ScoreState()

		try:
			self.db = MySQLdb.connect(host = self.MYSQLHOST, user = self.MYSQLUSERNAME, passwd = self.MYSQLPASSWORD, db = self.MYSQLDATABASE)
		except MySQLdb.OperationalError,err:
			print "MySQL Connect Error: ", err
			raise MyERROR("Couldn't connect")
		else:
			try:
				cursor = self.db.cursor()

				if self.GAMEID == None:
					cursor.execute("""SELECT max(id) FROM `game` """)
					maxgameid = cursor.fetchone()
					self.GAMEID = maxgameid[0]
				print "Using game %d"%self.GAMEID

				cursor.execute("""SELECT fi_team, server_ip, local_ip FROM `game-x-team` WHERE fi_game = "%s" ORDER BY fi_team"""%self.GAMEID)
				teamidsfromgame = cursor.fetchall()
				for teamidrow in teamidsfromgame:
					cursor = self.db.cursor()
					cursor.execute("""SELECT name FROM `team` WHERE id = "%s" """% teamidrow[0])
					namefromteam = cursor.fetchone()
					if namefromteam == None:
						print "Team with id %d doesn't exists"%teamidrow[0]
					self.ScoreState.AddTeam(teamidrow[0],namefromteam[0],teamidrow[1], teamidrow[2])
					print "added Team with id = %d name = %s vulnbox = %s network = %s teamcount = %d"%(teamidrow[0], namefromteam[0], teamidrow[1], teamidrow[2], self.ScoreState.Count())
			except:
				print "MySQL Error: "
				raise MyERROR("Error in Query")


	def PollScores(self):
		try:
			for TeamID in self.ScoreState.TeamIDs():
				# offensive scores
				cursor = self.db.cursor()
				cursor.execute("""SELECT sum(score) FROM scores WHERE (fi_game = "%s") and (fi_team = "%s") and (multiplier > 0) """%(self.GAMEID,TeamID))
				OffScoreFromTeam = cursor.fetchone()
				try:
					OffScore = int(OffScoreFromTeam[0])
				except:
					OffScore = 0

				# defensive scores
				cursor = self.db.cursor()
				cursor.execute("""SELECT sum(score) FROM scores WHERE (fi_game = "%s") and (fi_team = "%s") and (multiplier = 0) """%(self.GAMEID,TeamID))
				DefScoreFromTeam = cursor.fetchone()
				try:
					DefScore = int(DefScoreFromTeam[0])
				except:
					DefScore = 0

				# extra score
				cursor = self.db.cursor()
				cursor.execute("""SELECT score_extra FROM `game-x-team` WHERE (fi_game = "%s") and (fi_team = "%s") """%(self.GAMEID,TeamID))
				ExtraScoreFromTeam = cursor.fetchone()
				try:
					ExtraScore = int(ExtraScoreFromTeam[0])
				except:
					ExtraScore = 0

			#	print "building score from off=%d, def=%d, extra=%d"%(OffScore,DefScore,ExtraScore)
				score = Score(OffScore,DefScore,ExtraScore)
				self.ScoreState.NewScore(TeamID,score)
				#print """Score for """, self.ScoreState.TeamName(TeamID), """ is now """, self.ScoreState.TeamScore(TeamID)
			#for PlaceID in self.ScoreState.Places():
			#	print "Placed Team ",self.ScoreState.TeamName(PlaceID), " with score of " ,self.ScoreState.TeamScore(PlaceID).get_OffScore() ,self.ScoreState.TeamScore(PlaceID).get_DefScore() ,self.ScoreState.TeamScore(PlaceID).get_ExtraScore() 
			ev = NewScoreAnnouncementRequest(self.ScoreState.String())
			self.evManager.Notify(ev)
		except:
			print "MySQL Error: "
			raise MyERROR("Error in Query")


	def PollTimes(self):
		try:
			cursor = self.db.cursor()
			cursor.execute("""SELECT unix_timestamp(start) FROM game WHERE id="%s" """, self.GAMEID)
			starttimes = cursor.fetchone()
			self.TimeStart = starttimes[0]

			cursor = self.db.cursor()
			cursor.execute("""SELECT unix_timestamp(stop) FROM game WHERE id="%s" """, self.GAMEID)
			stoptimes = cursor.fetchone()
			self.TimeEnd = stoptimes[0]

			ev = NewTimeAnnouncementRequest(self.TimeStart,self.TimeEnd)
			self.evManager.Notify(ev)
		except:
			print "MySQL Error: "
			raise MyERROR("Error in Query")


	def PollScoreHistory(self):
		try:
			ValuesCount = 20
			timedelta = (self.TimeEnd - self.TimeStart)/ValuesCount
			for TeamID in self.ScoreState.TeamIDs():
				scorehistory = []
				timeakt = self.TimeStart
				while (timeakt <= self.TimeEnd):
					cursor = self.db.cursor()
					cursor.execute("""SELECT sum(score) FROM scores WHERE fi_team="%s" and unix_timestamp(time)<="%s" """,(TeamID,timeakt))
					teamscorehistory = cursor.fetchall()
					try:
						scorehistoryvalue = int(teamscorehistory[0][0])
					except:
						scorehistoryvalue = 0
					scorehistory.append(scorehistoryvalue)

					#print """Team %s has score %s at time %s"""%(self.ScoreState.TeamName(TeamID),teamscorehistory[0][0],timeakt)

					timeakt += timedelta
				self.ScoreState.NewScoreHistory(TeamID,scorehistory)

			ev = NewScoreHistoryAnnouncementRequest(self.ScoreState.String())
			self.evManager.Notify(ev)
		except:
			print "MySQL Error: "
			raise MyERROR("Error in Query")
	

	def PollScoreKoth(self):
		if self.KOTHSERVICEID != None and self.KOTHTEAMID != None:
			try:
				print "polling koth"
				cursor = self.db.cursor()
				#cursor.execute("""SELECT id FROM `game-x-flag` WHERE fi_game="%s" and fi_service="%s" and fi_team="%s" ORDER by id DESC LIMIT 1;""", (self.GAMEID,self.KOTHSERVICEID,self.KOTHTEAMID))
				cursor.execute("""SELECT id FROM `game-x-flag` WHERE fi_game="%s" and fi_service="%s" and fi_team="%s" ORDER by id DESC;""", (self.GAMEID,self.KOTHSERVICEID,self.KOTHTEAMID))
				flagid = cursor.fetchall()

				if flagid:
					cursor = self.db.cursor()
					cursor.execute("""SELECT fi_team FROM scores WHERE fi_flag="%s";""",flagid[0])

					teamids = cursor.fetchall()
					print " "
					print "Found %d koths"%len(teamids)
					for teamid in teamids:
						print "Koth:",teamid[0]

					if len(teamids) == 1:
						ev = NewScoreKothAnnouncementRequest(teamids[0][0])
					else:
						ev = NewScoreKothAnnouncementRequest(0)
					self.evManager.Notify(ev)
			except:
				print "MySQL Error: "
				raise MyERROR("Error in Query")


 	def Notify(self, event):
		if isinstance(event, DatabasePollEvent):
			if (event.times == True):
				self.PollTimes()
			if (event.scores == True):
				self.PollScores()
			if (event.scorehistory == True):
				self.PollScoreHistory()
			if (event.scorekoth == True):
				self.PollScoreKoth()
		elif isinstance(event, ServerConnectEvent):
			print "Polling the DB (initial)"
			self.PollAll()
			self.LastPoll = time.time()
		elif isinstance(event, TickEvent):
			TimePassed = time.time() - self.LastPoll
			if TimePassed >= self.Frequency:
				print "Polling the DB (scheduled)"
				self.PollAll()
				self.LastPoll = time.time()


	def PollAll(self):
		self.PollTimes()
		self.PollScores()
		self.PollScoreHistory()
		self.PollScoreKoth()

		#	for TeamID in self.ScoreState.TeamIDs():
		#		print """Team %s (id = %s) has score %s """%(self.ScoreState.TeamName(TeamID),TeamID,self.ScoreState.TeamScore(TeamID))



def ParseOpt(argv):
	CONNECTIP="127.0.0.1"
	CONNECTPORT=8000
	USERNAME = None
	PASSWORD = None
	MYSQLHOST = "127.0.0.1"
	MYSQLUSERNAME = None
	MYSQLPASSWORD = None
	MYSQLDATABASE = "ctf"
	GAMEID = None
	KOTHSERVICEID = None
	KOTHTEAMID = None
	FREQUENCY = 60
	try:
		opts,args=getopt.getopt(argv, "hm:u:w:d:f:i:p:U:P:I:S:T:", ["help","mysql-host=","mysql-username=","mysql-password=","mysql-database=","frequency=","game-id=","koth-service-id=","koth-team-id=","username=","password=","connect-ip=","connect-port="])
	except getopt.GetoptError,message:
		opterr(message)

	for opt,arg in opts:
		if opt in ("-h","--help"):
			helpexit()
		if opt in ("-m","--mysql-host"):
			MYSQLHOST = arg
		if opt in ("-u","--mysql-username"):
			MYSQLUSERNAME = arg
		if opt in ("-w","--mysql-password"):
			MYSQLPASSWORD = arg
		if opt in ("-d","--mysql-database"):
			MYSQLDATABASE = arg
		if opt in ("-f","--frequency"):
			try:
				FREQUENCY = int(arg)
				assert FREQUENCY >= 0 and FREQUENCY <= 600
			except:
				opterr("invalid parameter for --frequency")
		if opt in ("-I","--game-id"):
			try:
				GAMEID = int(arg)
				assert GAMEID >= 0 and GAMEID <= 65535
			except:
				opterr("invalid parameter for --game-id")
		if opt in ("-S","--koth-service-id"):
			try:
				KOTHSERVICEID = int(arg)
				assert KOTHSERVICEID >= 0 and KOTHSERVICEID <= 65535
			except:
				opterr("invalid parameter for --game-id")
		if opt in ("-T","--koth-team-id"):
			try:
				KOTHTEAMID = int(arg)
				assert KOTHTEAMID >= 0 and KOTHTEAMID <= 65535
			except:
				opterr("invalid parameter for --game-id")
		if opt in ("-U","--username"):
			USERNAME = arg
		if opt in ("-P","--password"):
			PASSWORD = arg
		if opt in ("-i","--connect-ip"):
			CONNECTIP = arg
		if opt in ("-p","--connect-port"):
			try:
				CONNECTPORT = int(arg)
				assert CONNECTPORT >= 0 and CONNECTPORT <= 65535
			except:
				opterr("invalid parameter for --connect-port")
	if len(args) > 0:
		opterr("don't know what to do with additional arguments")

	ConnectOptions = (CONNECTIP,CONNECTPORT)
	UserOptions = (USERNAME,PASSWORD)
	MysqlOptions = (MYSQLHOST,MYSQLUSERNAME,MYSQLPASSWORD,MYSQLDATABASE)
	GameOptions = (GAMEID,KOTHSERVICEID,KOTHTEAMID)
	return (ConnectOptions,UserOptions,MysqlOptions,GameOptions,FREQUENCY)

def opterr(msg):
	print "command line parse error:",msg
	print "use `%s -h' to get help"%sys.argv[0]
	sys.exit(1)

def helpexit():
	print "Usage `%s [option]'"%sys.argv[0]
	print ""
	print "Valid Options are:"
	print "  -i, --connect-ip           ip/hostname to connect to"
	print "  -p, --connect-port         port to connect to"
	print "  -U, --username             username to authenticate with"
	print "  -P, --password             password to authenticate with"
	print "  -m, --mysql-host           mysql servers hostname"
	print "  -u, --mysql-username       username for the mysql server"
	print "  -w, --mysql-password       password for the mysql server"
	print "  -d, --mysql-database       database for the mysql server"
	print "  -I, --game-id              gameid to query the database"
	print "  -S, --koth-service-id      Id of the service koth is scored as"
	print "  -T, --koth-team-id         id of the team with the ip" 
	print "                             that is running the koth-image"
	print "  -f, --frequency            pollfrequency"
	print "  -h, --help                 shows this help and exits"
	sys.exit(0)

def main(argv):
	(ConnectOptions,UserOptions,MysqlOptions,GameOptions,Frequency) = ParseOpt(argv)

	evManager = EventManager()

	log = TextLogView(evManager)
	spinner = CPUSpinnerController(evManager,2)
	phonyModel = PhonyModel(evManager)

	clientToServerEvents.extend([NewScoreAnnouncementRequest,NewScoreHistoryAnnouncementRequest,NewScoreKothAnnouncementRequest,NewTimeAnnouncementRequest])


	serverController = NetworkServerController(evManager, reactor)
	serverView = NetworkServerView(evManager, serverController, ConnectOptions, UserOptions, clientToServerEvents)
	try:
		gameDatabaseConn = GameDatabaseConnection(evManager,MysqlOptions,GameOptions, Frequency)
	except MyERROR:
		sys.exit(1)
	else:
		spinner.Run()

if __name__=="__main__":
	main(sys.argv[1:])
