
#*********************************************************************
# $Id: events.py 162 2008-12-16 12:48:49Z timo $
#
# CTF-VIS
# Visualization of Scoreboard and other Stuff for
# Capture the Flag - Games
#
# written by Timo Boettcher
# ctf-vis (near) spida (.) net
#
# (C) 2006 Timo Boettcher
# This is free software. You may redistribute copies of it under the
# terms of the GNU General Public License (Version 2)
# <http://www.gnu.org/licenses/gpl.html>.
# There is NO WARRANTY, to the extent permitted by law.
#
#*********************************************************************

class Event:
	def __init__(self):
		self.name = "Generic Event"

class TickEvent(Event):
	def __init__(self):
		self.name = "CPU Tick Event"

class SecondEvent(Event):
	def __init__(self):
		self.name = "Clock One Second Event"

class QuitEvent(Event):
	def __init__(self):
		self.name = "Program Quit Event"


class ServerConnectEvent(Event):
	def __init__(self, serverReference):
		self.name = "Network Server Connection Event"
		self.server = serverReference

class ClientConnectEvent(Event):
	def __init__(self, client):
		self.name = "Network Client Connection Event"
		self.client = client

class ClientDisconnectEvent(Event):
	def __init__(self, client):
		self.name = "Network Client Disconnection Event"
		self.client = client


# Container Event with recipientlist and event to send
class AdressedEvent(Event):
	def __init__(self, event, clientlist):
		self.name = "Adressed Event"
		self.event = event
		self.clientlist = clientlist


# Client Requests the Server to activate a new Playlist
class NewPlaylistRequest(Event):
	def __init__(self,playlists):
		self.name = "New Playlist Request"
		self.playlists = playlists
	def Acknowledge(self):
		return NewPlaylistEvent(self.playlists)
# Server Informs the Client about a change in the Playlist
class NewPlaylistEvent(Event):
	def __init__(self,playlists):
		self.name = "New Playlist Event"
		self.playlists = playlists


# Client Requests the Server to send a list of connected clients
class ClientListRequest(Event):
	def __init__(self):
		self.name = "Client List Request"
class ClientListEvent(Event):
	def __init__(self, DisplayList, DatabaseList, MasterList):
		self.name = "Client List Event"
		self.DisplayList = DisplayList
		self.DatabaseList = DatabaseList
		self.MasterList = MasterList


# Client Requests the Server to let the SQL-Client poll the Database
class DatabasePollRequest(Event):
	def __init__(self):
		self.name = "Database Poll Request"
		self.times = False
		self.scores = False
		self.scorehistory = False
	def Acknowledge(self):
		ev = DatabasePollEvent()
		ev.times = self.times
		ev.scores = self.scores
		ev.scorehistory = self.scorehistory
		return ev
# Server Requests the SQL-Client to poll the Database
class DatabasePollEvent(Event):
	def __init__(self):
		self.name = "Database Poll Event"
		self.times = False
		self.scores = False
		self.scorehistory = False


