
#*********************************************************************
# $Id: network.py 162 2008-12-16 12:48:49Z timo $
#
# CTF-VIS
# Visualization of Scoreboard and other Stuff for
# Capture the Flag - Games
#
# written by Timo Boettcher
# ctf-vis (near) spida (.) net
#
# (C) 2006 Timo Boettcher
# This is free software. You may redistribute copies of it under the
# terms of the GNU General Public License (Version 2)
# <http://www.gnu.org/licenses/gpl.html>.
# There is NO WARRANTY, to the extent permitted by law.
#
#*********************************************************************

try:
	import sys

	from twisted.spread import pb

	from manager import *
except ImportError, err:
	print "couldn't load module. %s" % (err)
	sys.exit(2)

# A list of ALL possible events that a server can send to a client
serverToDisplayEvents = []
serverToDatabaseEvents = []
serverToMasterEvents = []
# A list of ALL possible events that a client can send to a server
clientToServerEvents = []

#Mix-In Helper Functions
def MixInClass(origClass, addClass):
	if addClass not in origClass.__bases__:
		origClass.__bases__ += (addClass ,)

def MixInCopyClasses(someClass):
	MixInClass(someClass, pb.Copyable)
	MixInClass(someClass, pb.RemoteCopy)


# For each event class, if it is sendable over the network, we have
# to Mix In the "copy classes", or make a replacement event class that is
# copyable




# QuitEvent
# Direction: Client to Server only
MixInCopyClasses(QuitEvent)
pb.setUnjellyableForClass(QuitEvent, QuitEvent)
clientToServerEvents.append(QuitEvent)



# AdressedEvent
# Direction: Client to Server only
MixInCopyClasses(AdressedEvent)
pb.setUnjellyableForClass(AdressedEvent, AdressedEvent)
clientToServerEvents.append(AdressedEvent)


# CLientListRequest
# Direction: Client to Server only
MixInCopyClasses(ClientListRequest)
pb.setUnjellyableForClass(ClientListRequest, ClientListRequest)
clientToServerEvents.append(ClientListRequest)

# ClientListEvent
# Direction: Server to Client only
MixInCopyClasses(ClientListEvent)
pb.setUnjellyableForClass(ClientListEvent, ClientListEvent)
serverToMasterEvents.append(ClientListEvent)



# NewPlaylistRequest
# Direction: Client to Server only
MixInCopyClasses(NewPlaylistRequest)
pb.setUnjellyableForClass(NewPlaylistRequest, NewPlaylistRequest)
clientToServerEvents.append(NewPlaylistRequest)

# NewPlaylistEvent
# Direction: Server to Databaseclient only
MixInCopyClasses(NewPlaylistEvent)
pb.setUnjellyableForClass(NewPlaylistEvent, NewPlaylistEvent)
serverToMasterEvents.append(NewPlaylistEvent)



# DatabasePollRequest
# Direction: Client to Server only
MixInCopyClasses(DatabasePollRequest)
pb.setUnjellyableForClass(DatabasePollRequest, DatabasePollRequest)
clientToServerEvents.append(DatabasePollRequest)

# DatabasePollEvent
# Direction: Server to Databaseclient only
MixInCopyClasses(DatabasePollEvent)
pb.setUnjellyableForClass(DatabasePollEvent, DatabasePollEvent)
serverToDatabaseEvents.append(DatabasePollEvent)


MixInCopyClasses(QueueEvent)
pb.setUnjellyableForClass(QueueEvent, QueueEvent)

MixInCopyClasses(Queue)
pb.setUnjellyableForClass(Queue, Queue)

