#!/usr/bin/env python
#*********************************************************************
# $Id:  $
#
# random sql database filler
#
# written by Timo Boettcher
# ctf-vis (near) spida (.) net
#
# (C) 2006 Timo Boettcher
# This is free software. You may redistribute copies of it under the
# terms of the GNU General Public License (Version 2)
# <http://www.gnu.org/licenses/gpl.html>.
# There is NO WARRANTY, to the extent permitted by law.
#
#*********************************************************************

try:
	import sys
	import getopt

	import MySQLdb
	import time
	import datetime
	import random
except ImportError, err:
	print "couldn't load module. %s" % (err)
	sys.exit(2)

class GameDatabaseConnection:
	def __init__(self, MysqlOptions, Frequency, TeamCount, KotH):
		(self.MYSQLHOST,self.MYSQLUSERNAME,self.MYSQLPASSWORD,self.MYSQLDATABASE,self.GAMEID) = MysqlOptions
		self.Frequency = Frequency


		self.LastPoll = time.time()

		self.TimeStart = 0
		self.TimeEnd = 0

		self.teamids = []
		self.LastPoll = time.time()

		self.Teams = []
		self.KothService = 0
		self.services = []
		if self.GAMEID == "NEWGAME":
			self.NewGame(TeamCount,3,KotH)
		else:
			self.LoadGame()
		self.PollTimes()
		self.InsertScoreLoop(KotH)

	def NewGame(self,TeamCount,ServiceCount,KotH):
		self.db = MySQLdb.connect(host = self.MYSQLHOST, user = self.MYSQLUSERNAME, passwd = self.MYSQLPASSWORD, db = self.MYSQLDATABASE)
		cursor = self.db.cursor()
		cursor.execute("""SELECT max(id) FROM `game` """)
		maxgameid = cursor.fetchone()
		self.GAMEID = maxgameid[0] + 1
		cursor.execute("""SELECT max(id) FROM `team` """)
		maxteamid = cursor.fetchone()
		cursor.execute("""SELECT max(id) FROM `service` ORDER BY id """)
		maxserviceid = cursor.fetchone()

		GameXTeams = []
		TeamNames = []
		for TeamNumber in range(1,TeamCount+1):
			self.Teams.append(TeamNumber + maxteamid[0])
			TeamNames.append((TeamNumber + maxteamid[0],"Team %d"%(TeamNumber + maxteamid[0])))
			self.teamids.append((TeamNumber + maxteamid[0]))
			GameXTeams.append((self.GAMEID,TeamNumber + maxteamid[0],TeamNumber,TeamNumber))
		self.KotHImageTeam = maxteamid[0] + TeamCount + 1

		for ServiceNumber in range(1,ServiceCount+1):
			self.services.append(ServiceNumber + maxserviceid[0])
		self.KothService = maxserviceid[0]+ServiceCount+1

		start = str(datetime.datetime.now()).split(".")[0]
		stop = str(datetime.datetime.now() + datetime.timedelta(minutes=30)).split(".")[0]

		cursor.execute("""INSERT INTO `game` (id, name, start, stop, master, email, webpage, info) VALUES ("%s","CTF-VIS Test","%s", "%s", "Timo Boettcher", "ctf-vis@spida.net", "http://www.spida.net/projects/ctf-vis", NULL)"""%(self.GAMEID, start, stop))
		print "Created Game with id %d"%self.GAMEID
		for Team in TeamNames:
			cursor.execute("""INSERT INTO `team` (id, name, location, contact, email, webpage, members, info) VALUES ("%s", "%s", "NET, Test", "Team Controller", "team@example.com", "example.com", NULL, NULL) """%Team)
			print "Created Team %d"%Team[0]
		for GameXTeam in GameXTeams:
			cursor.execute("""INSERT INTO `game-x-team` (fi_game, fi_team, server_ip, local_ip, score_extra, info) VALUES ("%s", "%s", "10.%s.1.3", "10.%s.1.0/24", 10, NULL) """%GameXTeam)

		if KotH:
			cursor.execute("""INSERT INTO `team` (id, name, location, contact, email, webpage, members, info) VALUES ("%s", "KotH", "NET, Test", "Team Controller", "team@example.com", "example.com", NULL, NULL) """%(self.KotHImageTeam))
			cursor.execute("""INSERT INTO `game-x-team` (fi_game, fi_team, server_ip, local_ip, score_extra, info) VALUES ("%s", "%s", "10.123.1.3", "10.123.1.0/24", 10, NULL) """%(self.GAMEID,self.KotHImageTeam))
			print "Created KotH-Team %d"%self.KotHImageTeam

		for Service in self.services:
			cursor.execute("""INSERT INTO `service` (id, name, creator, info) VALUES ("%s", "Testservice", "Testservicewriter", "Testinfo") """%Service)
			cursor.execute("""INSERT INTO `game-x-service` (fi_game, fi_service, store, retrieve, flags_interval, flags_expire, score_offensive, score_defensive, score_uptime, info) VALUES ("%s", "%s","","","900","180","10","10","10", NULL) """%(self.GAMEID,Service))
			print "Created Service %d"%Service

		if KotH:
			cursor.execute("""INSERT INTO `service` (id, name, creator, info) VALUES ("%s", "Testservice", "Testservicewriter", "Testinfo") """%(maxserviceid[0]+ServiceCount+1))
			cursor.execute("""INSERT INTO `game-x-service` (fi_game, fi_service, store, retrieve, flags_interval, flags_expire, score_offensive, score_defensive, score_uptime, info) VALUES ("%s", "%s","","","900","180","10","10","10", NULL) """%(self.GAMEID,self.KothService))
			print "Created KotHService %d"%self.KothService


	def LoadGame(self):
		self.db = MySQLdb.connect(host = self.MYSQLHOST, user = self.MYSQLUSERNAME, passwd = self.MYSQLPASSWORD, db = self.MYSQLDATABASE)
		cursor = self.db.cursor()
		cursor.execute("""SELECT fi_team FROM `game-x-team` WHERE fi_game = "%s" ORDER BY fi_team"""%self.GAMEID)
		teamidsfromgame = cursor.fetchall()
		for teamid in teamidsfromgame:
			self.teamids.append(teamid[0])
			cursor.execute("""SELECT name FROM `team` WHERE id = "%s" """% teamid[0])
			namefromteam = cursor.fetchall()
			self.Teams.append(teamid[0])
		cursor.execute("""SELECT id FROM `service` ORDER BY id""")
		availableservices = cursor.fetchall()
		for s in availableservices:
			self.services.append(s[0])


	def PollTimes(self):
		cursor = self.db.cursor()
		cursor.execute("""SELECT unix_timestamp(start) FROM game WHERE id="%s" """, self.GAMEID)
		starttimes = cursor.fetchall()
		self.TimeStart = starttimes[0][0]

		cursor = self.db.cursor()
		cursor.execute("""SELECT unix_timestamp(stop) FROM game WHERE id="%s" """, self.GAMEID)
		stoptimes = cursor.fetchall()
		self.TimeEnd = stoptimes[0][0]

	def InsertScoreLoop(self,KotH):
		while True:
			time.sleep(self.Frequency)
			self.InsertScore(KotH)

	def InsertScore(self,KotH):
		self.db = MySQLdb.connect(host = self.MYSQLHOST, user = self.MYSQLUSERNAME, passwd = self.MYSQLPASSWORD, db = self.MYSQLDATABASE)
		cursor = self.db.cursor()
		for Team in self.Teams:
			time = str(datetime.datetime.now()).split(".")[0]
			service = random.choice(self.services)
			flag = random.randint(0, 1000000)
			event = random.randint(0, 1000000)
			multiplier = random.randint(0, 5)
			score = random.randint(0, 20)
			try:
				cursor.execute("""INSERT INTO `scores` (fi_game, fi_service, fi_flag, fi_team, fi_event, multiplier, time, score) VALUES ("%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s") """%(self.GAMEID,service,flag,Team,event,multiplier,time,score))

			except:
				print "Found a value that already exists"
		if KotH:
			TeamKotH = random.choice(self.Teams)
			print "selecting %s as KotH"%TeamKotH
			cursor.execute("""SELECT max(id) FROM `game-x-flag` """)
			maxid = cursor.fetchone()
			id = int(maxid[0]) + 1
			flag = random.randint(0, 1000000)
			flagid = random.randint(0, 1000000)
			validfrom = str(datetime.datetime.now()).split(".")[0]
			validuntil = str(datetime.datetime.now()).split(".")[0]
			validexpires = str(datetime.datetime.now()).split(".")[0]
			cursor.execute("""INSERT INTO `game-x-flag` (id, fi_game, fi_service, fi_team, valid_from, valid_until, valid_expires, flag_id, flag) VALUES ("%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s") """%(id,self.GAMEID,self.KothService,self.KotHImageTeam,validfrom,validuntil,validexpires,flagid,flag))

			event = random.randint(0, 1000000)
			multiplier = random.randint(0, 5)
			score = random.randint(0, 20)
			cursor.execute("""INSERT INTO `scores` (fi_game, fi_service, fi_flag, fi_team, fi_event, multiplier, time, score) VALUES ("%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s") """%(self.GAMEID,service,id,TeamKotH,event,multiplier,time,score))

def ParseOpt(argv):
	MYSQLHOST = "127.0.0.1"
	MYSQLUSERNAME = "root"
	MYSQLPASSWORD = "ctf-test"
	MYSQLDATABASE = "ctf"
	GAMEID = "NEWGAME"
	FREQUENCY = 60
	TEAMCOUNT = 10
	try:
		opts,args=getopt.getopt(argv, "hm:u:w:d:f:t:I:", ["help","mysql-host=","mysql-username=","mysql-password=","mysql-database=","frequency=","teamcount=","game-id="])
	except getopt.GetoptError,message:
		opterr(message)

	for opt,arg in opts:
		if opt in ("-h","--help"):
			helpexit()
		if opt in ("-m","--mysql-host"):
			MYSQLHOST = arg
		if opt in ("-u","--mysql-username"):
			MYSQLUSERNAME = arg
		if opt in ("-w","--mysql-password"):
			MYSQLPASSWORD = arg
		if opt in ("-d","--mysql-database"):
			MYSQLDATABASE = arg
		if opt in ("-f","--frequency"):
			try:
				FREQUENCY = int(arg)
				assert FREQUENCY >= 0 and FREQUENCY <= 600
			except:
				opterr("invalid parameter for --frequency")
		if opt in ("-t","--teamcount"):
			try:
				TEAMCOUNT = int(arg)
				assert TEAMCOUNT >= 0 and TEAMCOUNT <= 50
			except:
				opterr("invalid parameter for --teamcount")
		if opt in ("-I","--game-id"):
			try:
				GAMEID = int(arg)
				assert GAMEID >= 0 and GAMEID <= 65535
			except:
				opterr("invalid parameter for --game-id")
	if len(args) > 0:
		opterr("don't know what to do with additional arguments")

	MysqlOptions = (MYSQLHOST,MYSQLUSERNAME,MYSQLPASSWORD,MYSQLDATABASE,GAMEID)
	return (MysqlOptions,FREQUENCY,TEAMCOUNT)

def opterr(msg):
	print "command line parse error:",msg
	print "use `%s -h' to get help"%sys.argv[0]
	sys.exit(1)

def helpexit():
	print "Usage `%s [option]'"%sys.argv[0]
	print ""
	print "Valid Options are:"
	print "  -m, --mysql-host           mysql servers hostname"
	print "  -u, --mysql-username       username for the mysql server"
	print "  -w, --mysql-password       password for the mysql server"
	print "  -d, --mysql-database       database for the mysql server"
	print "  -I, --game-id              gameid to query the database"
	print "  -f, --frequency            pollfrequency"
	print "  -t, --teamcount            number of teams to create"
	print "  -h, --help                 shows this help and exits"
	sys.exit(0)

def main(argv):
	(MysqlOptions,Frequency,TeamCount) = ParseOpt(argv)

	KotH = True
	gameDatabaseConn = GameDatabaseConnection(MysqlOptions, Frequency,TeamCount, KotH)

if __name__=="__main__":
	main(sys.argv[1:])
